--- /dev/null	Sun Aug  5 23:41:09 2018
+++ new/usr/src/man/man3c/listen.3c	Sun Aug  5 23:41:09 2018
@@ -0,0 +1,102 @@
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License (the "License").
+.\" You may not use this file except in compliance with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\"
+.\" Copyright 1989 AT&T
+.\" Copyright (C) 1999, Sun Microsystems, Inc. All Rights Reserved.
+.\" Copyright 2018 Nexenta Systems, Inc.
+.\"
+.Dd August 2, 2018
+.Dt LISTEN 3C
+.Os
+.Sh NAME
+.Nm listen
+.Nd listen for connections on a socket
+.Sh LIBRARY
+.Lb libc
+.Sh SYNOPSIS
+.In sys/types.h
+.In sys/socket.h
+.Ft int
+.Fo listen
+.Fa "int s"
+.Fa "int backlog"
+.Fc
+.Sh DESCRIPTION
+To accept connections, a socket is first created with
+.Xr socket 3C ,
+a backlog for incoming connections is specified with
+.Fn listen
+and then the connections are accepted with
+.Xr accept 3C .
+The
+.Fn listen
+call applies only to sockets of type
+.Dv SOCK_STREAM
+or
+.Dv SOCK_SEQPACKET .
+.Pp
+The
+.Fa backlog
+parameter defines the maximum length the queue of pending connections may grow
+to.
+.Pp
+If a connection request arrives with the queue full, the client will receive an
+error with an indication of
+.Er ECONNREFUSED
+for
+.Dv AF_UNIX
+sockets.
+If the underlying protocol supports retransmission, the connection request may
+be ignored so that retries may succeed.
+For
+.Dv AF_INET
+and
+.Dv AF_INET6
+sockets, the TCP will retry the connection.
+If the
+.Fa backlog
+is not cleared by the time the tcp times out, the connect will fail with
+.Er ETIMEDOUT .
+.Sh RETURN VALUES
+A 0 return value indicates success; -1 indicates an error.
+.Sh ERRORS
+The call fails if:
+.Bl -tag -width Er
+.It Bq Er EBADF
+The argument
+.Fa s
+is not a valid file descriptor.
+.It Bq Er ENOTSOCK
+The argument
+.Fa s
+is not a socket.
+.It Bq Er EOPNOTSUPP
+The socket is not of a type that supports the operation
+.Fn listen .
+.El
+.Sh MT-LEVEL
+.Sy Safe
+.Sh SEE ALSO
+.Xr accept 3C ,
+.Xr connect 3C ,
+.Xr socket 3C ,
+.Xr socket.h 3HEAD ,
+.Xr attributes 5
+.Sh NOTES
+There is currently no
+.Fa backlog
+limit.
